//---------------------------------------------------------------------------//
//    MYRESULT.PRG
//
//    Author: Hector Pezoa - `HPGSOFT - 2007
//    Realizada con la libreria Ot4xb de Pablo Botella
//    Algunos metodos o ideas estan basados en la excelente
//    libreria de Manu Exposito Eagle
//
//    Realized with the library Ot4xb of Pablo Botella  Get The Open Tools for Xbase++
//    here: http://www.xbwin.com
//    Some methods or ideas are based on the excellent
//    library Eagle of Manu Exposito
//
//  Contents://
//---------------------------------------------------------------------------//

#include "dll.ch"
#include "ot4xb.ch"
#include "common.ch"
#INCLUDE "appevent.ch"
#INCLUDE "dbstruct.ch"
#INCLUDE "mysql.ch"
#INCLUDE "dcdialog.ch"


#PRAGMA LIBRARY( "ot4xb.LIB" )

//Set( _SET_DATEFORMAT, 'dd-mm-yyyy' )


CLASS MyResult

  EXPORTED:
  VAR oConnect , cSql , aStructSql , nRow , pResult ,nSkipper
  VAR nFields         //Numero columnas      Number columns
  VAR nRows           //Numero filas en la tabla  number rows on the table
  VAR lBof , lEof , cTable, aBuffer, aBufferOld , aBlank , nLenStruct
  VAR nCurRow ,lKeyFlag , lIncFlag , aKeyFlag ,  nIncFlag , cOrderBy
  VAR cWhere  , cHaving , nLimit , uValFind , lOkFind , nColFind

  METHOD Init
  METHOD ExecuteSql
  METHOD OpenRecord
  METHOD GetRowData
  METHOD LoadData

  METHOD Insert
  METHOD Delete
  METHOD Update
  METHOD Where
  METHOD Find
  METHOD FindNext
  METHOD BlobImagen

  INLINE METHOD FCount() ; return ::nFields
  INLINE METHOD FieldCount() ; return ::nFields
  INLINE METHOD Bof()      ; return ::lBof
  INLINE METHOD Eof()      ; return ::lEof
  INLINE METHOD RecNo()    ; return ::nCurRow
  INLINE METHOD LastRec()  ; return ::nRows
  INLINE METHOD GoTo(n)    ; return ::GetRowData(n)
  INLINE METHOD GoTop()    ; return ::GetRowData(1)
  INLINE METHOD GoBottom() ; return ::GetRowData(::nRows)
  INLINE METHOD RecCount() ; return ::nRows

  INLINE METHOD SetNoIVar( c , val )  ;  return ::FieldPut( c, val )
  INLINE METHOD GetNoIVar( c ) ;  return ::FieldGet(c)

  INLINE METHOD NoMethod( c )
       local n
       local pc := PCount()
       local a  := Array( pc - 1)
       local r  := NIL
       for n := 2 to pc
          a[n-1] := PValue(n)
       next
       lCallFuncPa( c , a , @r)
       return r


  METHOD Skip
  METHOD Skipper

  METHOD RefreshAll
  METHOD SetOrder
  METHOD Close
  METHOD Blank

  METHOD FieldGet
  METHOD FieldPut

  METHOD FieldPos
  METHOD FieldName
  METHOD FieldLen
  METHOD FieldDec
  METHOD FieldType

  ENDCLASS
//---------------------------------------------------------------------------//
 METHOD MyResult:Init(pMySql,cSql, cTable, cWhere,cHaving,cOrderBy,nLimit)

 ::oConnect := pMysql

     IF !empty(cSql)
         ::cSql := cSql
     else
        if (  ::oConnect:ExistTables( cTable ) )

             cOrderBy := if( ValType( cOrderBy ) == "N",  AllTrim( str( cOrderBy ) ), cOrderBy )
             ::cTable  := cTable
             if cWhere   != NIL ; ::cWhere   := cWhere ;end
             if cHaving  != NIL ; ::cHaving  := cHaving ;end
             if cOrderBy != NIL ; ::cOrderBy := cOrderBy ;end
             if nLimit   != NIL ; ::nLimit   := nLimit ;end

             ::cSql := 'SELECT * FROM ' + ::cTable
             ::cSql += if( empty( ::cWhere ), '',   ' WHERE ' + ::cWhere )
             ::cSql += if( empty( ::cHaving ), '',  ' HAVING ' + ::cHaving )
             ::cSql += if( empty( ::cOrderBy ), '', ' ORDER BY ' + ::cOrderBy )
             ::cSql += if( empty( ::nLimit ), '',  ' LIMIT ' + AllTrim( str( ::nLimit ) ) )

        else
           ** msgbox("No Existe Table")     //Table Does not exist
            MyerrorLog(MY001)
            return NIL
       endif
  endif

return self
//---------------------------------------------------------------------------//
METHOD MyResult:ExecuteSql(cSql)

     If empty(cSql)
        msgbox("Error no hay sentencia")    //error there is no a question
       return NIL
     end
     cSql := AllTrim(cSql)

     If ::oConnect:Ping() <> 0
         MySQLError(::oConnect, "Ping Fail")
        return .f.
     end

     if ::oConnect:RealQuery(cSql ) <> 0
         MySQLError(::oConnect, "Query Fail")
         return .f.
     end
return (::oConnect:StoreResult())
 //---------------------------------------------------------------------------//
METHOD MyResult:OpenRecord(cSql)
local  i,  rc , aPFields, Len, nDec  ,aDatanew, aStructSql,xn

 ::aStructSql    := {}
 ::nCurRow       := 1
 ::pResult       := NIL
 ::aBuffer       := {}
 ::aBlank        := {}
 ::nLenStruct    := 0
 ::lKeyFlag      := .F.
 ::lIncFlag      := .F.
 ::aKeyFlag      := {}
 ::nIncFlag      := 0
 ::nColFind      := 1
 ::nSkipper      := .F.

  IF Valtype(cSql) = 'C'
     ::cSql  := cSql
  ENDIF

  if (::pResult := ::EXECUTESQL(::cSql)) > 0

       ::nRows       := mysql_num_rows(::pResult)
       ::nFields     := mysql_num_fields(::pResult)

        if  ::nRows > 0
            ::lEof      := .f.
            ::lBof      := .f.
         else
            ::lEof      := .t.
            ::lBof      := .t.
         endif

           for i := 1 to ::nFields
                aPFields := InfoField(::pResult)
              if( aPFields != NIL )
                AAdd(::aStructSql, aPFields)

                if (nAND( ::aStructSql[i][MYSQL_FS_FLAGS], AUTO_INCREMENT_FLAG) == AUTO_INCREMENT_FLAG)
                   ::lIncFlag := .T.
                   ::nIncFlag := i
                endif

                if (nAND(::aStructSql[i][MYSQL_FS_FLAGS], PRI_KEY_FLAG) == PRI_KEY_FLAG)
                    AAdd(::aKeyFlag,{i, PRI_KEY_FLAG})
               endif

                if (nAND(::aStructSql[i][MYSQL_FS_FLAGS],UNIQUE_KEY_FLAG) == UNIQUE_KEY_FLAG)
                    AAdd(::aKeyFlag,{i, UNIQUE_KEY_FLAG})
                endif

                if (nAND(::aStructSql[i][MYSQL_FS_FLAGS], MULTIPLE_KEY_FLAG) == MULTIPLE_KEY_FLAG)
                    AAdd(::aKeyFlag,{i, MULTIPLE_KEY_FLAG})
                endif

            endif
           Next

          ::lKeyFlag    := ( len( ::aKeyFlag ) > 0 )
          ::nLenStruct  := len(::aStructSql)
          ::GetRowData(::nCurRow)
   else
       MyerrorLog("error in opening a table")
       return .f.
  endif

Return .T.
 //---------------------------------------------------------------------------//
METHOD MyResult:RefreshAll()
local lresp := .t.
   mysql_free_result(::pResult)

   if (::pResult := ::EXECUTESQL(::cSql)) > 0
       ::nRows :=  mysql_num_rows(::pResult)
       ::nCurRow := ::nRows
       ::GetRowData(::nCurRow)
   else
       lresp := .f.
   endif

return lresp
//---------------------------------------------------------------------------//
 METHOD MyResult:GetRowData(nRow)
  local aPRow := {}
  local i  ,cType , cName , Value, aBuffer , lbof, lastrec, leof, recno
   local cFDate := set(4)
  i = 0
  default nRow to ::nCurRow

 if ::oConnect <> NIL
      aBuffer      := Array(  ::nLenStruct  )
    ::aBufferOld   := Array(  ::nLenStruct  )
    ::lBof := ( EMPTY( ::LastRec() ) )
     lbof := ( EMPTY( ::LastRec() ) )
     lastrec := ::Lastrec()
     recno := ::Recno()

      if nRow < 1 .or. nRow > ::lastrec()
          nRow     := ::lastrec() + 1
         ::nCurRow := ::lastrec() + 1
      endif

      if nRow >= 1 .AND. nRow <= ::nRows
            mysql_data_seek(::pResult,nRow-1)
           ::nCurRow := nRow
      endif
      ::lEof := ( ::Recno() > ::LastRec() )
      leof := ( ::Recno() > ::LastRec() )

      if ! ::eof()
           aPRow := mysql_fetch_row(::pResult)

      endif

      if  len(aPRow) > 0
         for i := 1 to ::nFields
           cType := ::aStructSql[i][MYSQL_FS_TYPEXBASE]
             do case
               case cType == 'C'
                    aBuffer[i] :=  aProw[i]
               case cType == 'M'
                    aBuffer[i] :=  aProw[i]
               case cType == 'N'  .OR. cType =='B'
                       If aProw[i] = nil
                          aBuffer[i] := 0
                       else
                         aBuffer[i] := val(aProw[i])
                       endif
               case cType == 'D'
                      IF Empty(aProw[i] )
                         If aProw[i] = nil
                            aBuffer[i] := HpSToD("")
                         else
                            aBuffer[i] := HpSToD()
                         endif
                      ELSE
                          aBuffer[i] := HpSToD(Left(aProw[i],4)+SubStr(aProw[i],6,2 )+Right(aProw[i],2))
                      ENDIF

              case cType == 'L'
                     aBuffer[i] := if( aProw[i] ,.T.,.F. )
               othe
                     aBuffer[i] :=  aProw[i]
             endcase
         next
       else
            ::aBuffer  = Aclone(::aBlank)
       endif
    endif
    ::aBuffer    = Aclone(aBuffer)
    ::aBufferOld = Aclone(aProw)

return nil
 //---------------------------------------------------------------------------//
METHOD MyResult:Close()

    mysql_free_result(::pResult)

return Self
 //---------------------------------------------------------------------------//
METHOD MyResult:Blank(lBlank)
local i ,cType,xn

  ::aBlank        := {}
  for i := 1 to ::nFields
      cType := ::aStructSql[i][MYSQL_FS_TYPEXBASE]

      DO CASE
         CASE cType == 'C'
              xn := SPACE(::aStructSql[i][MYSQL_FS_LENGTH ])
        CASE cType == 'N'
             nDec :=   ::aStructSql[i][MYSQL_FS_DECIMALS]
             IF nDec = 0
                 xn := 0
             else
                 xn = val("0."+replicate("0", nDec))
             ENDIF
        CASE cType == 'D'
             xn := CToD(space(8))
        CASE cType == 'L'
              xn := .F.
       CASE cType == 'M'
             xn := ''
        ENDCASE
        AAdd(::aBlank , xn)
   next

   if lBlank
      For i := 1 TO ::nLenStruct
         ::FieldPut(i,::aBlank[i])
      next
   endif

 return nil
  //---------------------------------------------------------------------------//
  METHOD MyResult:Skip(nSkip)
 Local lbof, nCurRow , lbof1,lastrec, recno

   default nSkip to 1
   ::lBof := ( EMPTY( ::LastRec() ) )
   lbof1 := ( EMPTY( ::LastRec() ) )
   lastrec := ::LastRec()
   recno := ::recno()
   DO CASE
     case nSkip == 0

     case nSkip < 0
           if ( ( ::recno() + nSkip ) + 0 ) < 1
             nSkip := - ::recno() + 1
            ::lBof := .T.
         endif
     case nSkip > 0
         if ( ( ::recno() + nSkip ) + 0 ) > ::lastrec()
            IF ::nSkipper
               nSkip := ::lastrec() - ::recno() +1
            else
                nSkip := ::lastrec() - ::recno()
            endif
               ::lEof := .T.
        endif
     endcase

   ::nCurRow  := ::nCurRow + nSkip
   nCurRow    := ::nCurrow
   lbof       := ::bof()

   ::getRowData(::nCurrow)

  if lbof
      ::lBof := .T.
   endif

return nil
//---------------------------------------------------------------------------//
 METHOD MyResult:Skipper(nSkip)
 LOCAL i  :=  0
   default nSkip to 1
  ::nSkipper := .T.

   do case
   case ( nSkip == 0 .or. ::lastrec() == 0 )
          ::Skip( 0 )

  case ( nSkip > 0 .and. !::eof() )

        while ( i < nSkip )
          ::skip( 1 )
          if ::eof()
            ::skip( -1 )
             ::nSkipper := .f.
            exit
         endif
         i++
        enddo

   case ( nSkip < 0 )

        while ( i > nSkip )
          ::skip( -1 )
          if ::bof()
            ::nSkipper := .f.
          exit
         endif
         i--
       enddo
    endcase

   RETURN i
//---------------------------------------------------------------------------//
METHOD MyResult:FieldGet(c)
local nNum, nValue
local  uName

   if ValType(c) == "C"
      uName := Upper(c)
      nNum :=   ASCAN(::aStructSql, { |x| UPPER(x[1]) == uName })
     //   nNum := ::FieldPos(c)
   else
      nNum := c
   endif
   if nNum > 0 .AND. nNum <= ::nfields
       nValue := ::aBuffer[ nNum ]

       if   ::aStructSql[nNum][MYSQL_FS_TYPEXBASE]   == "C"
            nValue := PadR(nValue,::aStructSql[nNum][MYSQL_FS_LENGTH])
       endif

   endif

return nValue
 //---------------------------------------------------------------------------//
  METHOD MyResult:FieldPut(c, Value)
 local nNum
 local  uName

   if ValType(c) == "C"
      uName := Upper(c)
      nNum := ASCAN(::aStructSql, { |x| UPPER(x[1]) == uName })
   else
      nNum := c
   endif

   if nNum > 0 .AND. nNum <= Len(::aBuffer)

      if Valtype(Value) == Valtype(::aBuffer[nNum]) .OR. ::aBuffer[nNum]==NIL
         if ValType(Value) == "C"
            Value := RTrim(Value)
         endif
         ::aBuffer[nNum] := Value
      elseif Valtype(Value)=="D"
        ::aBuffer[nNum] := Value
      endif
   endif
 return Value
 //---------------------------------------------------------------------------//
 METHOD MyResult:FieldPos(cName)
 local uName, nPos := 0

  uName := Upper(cName)
  IF VALTYPE(uName) = "C"
      nPos :=  ASCAN(::aStructSql, { |x| UPPER(x[1]) == uName })
  endif

 return nPos
 //---------------------------------------------------------------------------//
 METHOD MyResult:FieldName(nNum)
 Local cName := ''
   if nNum >=1 .AND. nNum <= ::nLenStruct
      cName := ::aStructSql[nNum][MYSQL_FS_NAME]
   endif

return cName
//---------------------------------------------------------------------------//
 METHOD MyResult:FieldLen(nNum)
 Local nLargo := 0
   if nNum >=1 .AND. nNum <= ::nLenStruct
      nLargo := ::aStructSql[nNum][MYSQL_FS_LENGTH]
   endif

return nLargo
//---------------------------------------------------------------------------//
 METHOD MyResult:FieldDec(nNum)
 Local nDec :=  0
   if nNum >=1 .AND. nNum  <= ::nLenStruct
      nDec := ::aStructSql[nNum][MYSQL_FS_DECIMALS]
   endif

return nDec
 //---------------------------------------------------------------------------//
  METHOD MyResult:FieldType(nNum)
 local cType := "U"

   if nNum >=1 .AND. nNum  <= ::nLenStruct
      cType :=  ::aStructSql[nNum][MYSQL_FS_TYPEXBASE]
   endif

return cType
 //---------------------------------------------------------------------------//
METHOD MyResult:Insert( )
local cSql :=   "INSERT INTO " + ::cTable + " ("
local lRet := .f.
local i := 0
local aData := ::LoadData(1)
local  lvalue

  for i  := 1 to ::nLenStruct
      IF  aData[i] <> nil .AND. !(nAND( ::aStructSql[i][MYSQL_FS_FLAGS], AUTO_INCREMENT_FLAG) == AUTO_INCREMENT_FLAG)
          cSql +=  ::aStructSql[i][MYSQL_FS_NAME] +","
      endif
   next

 cSql := Left( cSql, Len( cSql ) - 1 ) + ") VALUES ("

 for i  := 1 to ::nLenStruct
     IF  aData[i] <> nil .AND. !(nAND( ::aStructSql[i][MYSQL_FS_FLAGS], AUTO_INCREMENT_FLAG) == AUTO_INCREMENT_FLAG)
         cSql += "'"+ aData[i]+"'"+","
    endif
next
cSql := Left( cSql, Len(cSql) - 1 ) + ")"

 if ::ExecuteSql(cSql) == Nil
    ::RefreshAll()
    lRet := .T.
 endif

return( lRet )
 //---------------------------------------------------------------------------//
 METHOD MyResult:Delete( nLimit)
local cSql := 'DELETE FROM ' + ::cTable + ::Where()

local lRet := .f.

cSql += if( ValType( nLimit ) == 'N' .and. nLimit > 0,  ' LIMIT ' + AllTrim( str( nLimit ) ), '' )

       if ::ExecuteSql(cSql) == Nil
           ::RefreshAll()
                                  //erased record
           lRet := .T.
       endif

return( lRet )
 //---------------------------------------------------------------------------//
METHOD MyResult:Update( nLimit)
local cSql :=   "UPDATE " + ::cTable + " SET "
local aDataNew := ::LoadData(1)
local aDataOld := ::aBufferOld
local lRet := .F.
local i
local n := 0

      for i := 1 to  ::nLenStruct
            IF  (aDataNew[i]) == (aDataOld[i])

            else
                cSql += ::aStructSql[i][MYSQL_FS_NAME] + "="  + "'"+ aDataNew[i]+"'" + ","
                n := n+1
            endif
       next
       IF n = 0
           return lRet
       ENDIF

       cSql = Left(cSql, Len(cSql) - 1)
       cSql += ::Where()

       cSql += if( ValType( nLimit ) == 'N' .and. nLimit > 0, ;
                ' LIMIT ' + AllTrim( str( nLimit ) ), '' )
        if ::ExecuteSql(cSql) == Nil
           ::RefreshAll()
            lRet := .T.
        endif
    n = 0
return( lRet )

 //---------------------------------------------------------------------------//
METHOD MyResult:LoadData(nTypo)
local i := 0 , cType
local cValue := ''
local aXbaseBuffer  := Array(  ::nLenStruct  )

    FOR i := 1 TO ::nLenStruct
        cType := ::aStructSql[i][MYSQL_FS_TYPEXBASE]
        do case
           case cType == 'C'
                aXbaseBuffer[i]  := ConvertXbase(::FieldGet(i))

           case cType == 'M'
                aXbaseBuffer[i]  := ::FieldGet(i)

           case cType == 'N'
                IF nTypo == 1
                   aXbaseBuffer[i] := str(::FieldGet(i))
                else
                   aXbaseBuffer[i] := ConvertXbase(::FieldGet(i))
               endif
          case cType == 'D'
                IF nTypo == 1
                   aXbaseBuffer[i] := DTOS(::FieldGet(i))
                ELSE
                   aXbaseBuffer[i] := ::FieldGet(i)
                ENDIF
         case cType == 'L'
                    aXbaseBuffer[i] := if( ::FieldGet(i), '1', '0' )

          othe
                  aXbaseBuffer[i]  := ConvertXbase(::FieldGet(i))
                        **  msgbox('puede haber error')       //there can be error
                   //  MyerrorLog("there can be error- LoadData")
       endcase
    next

 return aXbaseBuffer
 //---------------------------------------------------------------------------//

METHOD MyResult:SetOrder( nCol )
local cType := ValType( nCol )

    if cType == "N"
        if nCol > 0 .and. nCol < ::FCount()
            ::cOrderBy := LTrim( str( nCol ) )
            ::cSql := 'SELECT * FROM ' + ::cTable
            ::cSql += if( empty( ::cWhere ), '', ' WHERE ' + ::cWhere )
            ::cSql += if( empty( ::cHaving ), '', ' HAVING ' + ::cHaving )
            ::cSql += if( empty( ::cOrderBy ), '', ' ORDER BY ' + ::cOrderBy )
            ::cSql += if( empty( ::nLimit ), '', ' LIMIT ' + AllTrim( str( ::nLimit ) ) )
            ::OpenRecord()
        else
           ** Msgbox( "No es un numero de columna valido")    //it is not a correct number of column
             MyerrorLog("MY006")
             return .f.
        endif
    elseif cType == "C"
        ::cOrderBy := AllTrim( nCol )
        ::cSql := 'SELECT * FROM ' + ::cName
        ::cSql += if( empty( ::cWhere ), '', ' WHERE ' + ::cWhere )
        ::cSql += if( empty( ::cHaving ), '',' HAVING ' + ::cHaving )
        ::cSql += if( empty( ::cOrderBy ), '', ' ORDER BY ' + ::cOrderBy )
        ::cSql += if( empty( ::nLimit ), '', ' LIMIT ' + AllTrim( str( ::nLimit ) ) )
        ::OpenRecord()
    endif

return .T.

//---------------------------------------------------------------------------//
  METHOD MyResult:Where()
 Local nField  :=  0
 Local cField  := ''
 Local cWhere  :=  " WHERE "
 Local i       := 1
 Local n       := 1
 Local aData   := ::aBufferOld

      IF ::lIncFlag
          n :=  ::nIncFlag
         cWhere += ::aStructSql[n][MYSQL_FS_NAME] + "="  + "'"+ aData[n]+"'"
      elseif  ::lKeyFlag

         i := len( ::aKeyFlag )
         if i == 1
             n :=  ::aKeyFlag[i,1]
            cWhere += ::aStructSql[n][MYSQL_FS_NAME] + ' = ' + "'"+ aData[n]+"'"
         else
            nField := i
            FOR i := 1 TO nField
                n := ::aKeyFlag[i,1 ]
                cWhere += ::aStructSql[i][MYSQL_FS_NAME] + "="
               cWhere +=  "'"+ aData[n]+"'"
               cWhere += " AND "
            next
            cWhere := Left(cWhere, Len(cWhere) - 5)
          end
      else
          for i := 1 to ::nLenStruct
             cWhere += ::aStructSql[i][MYSQL_FS_NAME] + "="
             cWhere +=  "'"+ aData[i]+"'"
             cWhere += " AND "
          next
          cWhere := Left(cWhere, Len(cWhere) - 5)
     end

return( cWhere )
 //---------------------------------------------------------------------------//
METHOD MyResult:Find( nCol,uVal,lTop)
local lOk := .f.
local cFldGet := ""

      ::lOkFind := .f.

    if ValType( nCol ) == "N" .and. nCol > 0
        if nCol > ::FCount()
            ** msgbox( "Se paso en el nmero de columnas...")          //pass in the number of columns
             MyerrorLog("pass in the number of columns ")

         else
            ::nColFind := nCol
            lOk := .t.
        endif
    else
       ** msgbox( "Error en la asignacin...")        //Error in the allocation
         MyerrorLog("Error in the allocation ")
    endif

    if lOk .and. !empty( uVal )
        if ValType( uVal ) == "C"
            ::uValFind := AllTrim( uVal )
        endif
        lTop := if( ValType( lTop ) == "L", lTop, .f. )
    else
      **  msgbox( "Este valor no puede estar vaco...")      //This value cannot be empty
        MyerrorLog("This value cannot be empty")

        lOk := .f.
    endif

    if lOk
        if( lTop, ::GoTop(), )
        while !::Eof()
            ::LoadData()
             if Valtype(cFldGet) = 'C'
                cFldGet := alltrim(::FieldGet( nCol ))
             endif
             if ::uValFind = cFldGet
                ::lOkFind := .t.
                EXIT
            endif
            ::Skip( 1 )
        end
    endif

return( ::lOkFind )
 //---------------------------------------------------------------------------//
 METHOD MyResult:FindNext()
local cFldGet := ""

    if ::lOkFind
        ::lOkFind := .f.
        while !::Eof
            ::LoadData()
            cFldGet := ::FieldGet( ::nColFind )
            if ValType( cFldGet ) == "C"
                  cFldGet := alltrim(::FieldGet( nCol ))
             endif
             if ::uValFind == cFldGet
                ::lOkFind := .t.
                EXIT
            endif
            ::Skip( 1 )
        end
    endif

return( ::lOkFind )
//---------------------------------------------------------------------------//

METHOD MyResult:BlobImagen( cPicture)
LOCAL nHandle
lOCAL nRead    := 0
LOCAL nPos     := 0
LOCAL nSize    := 0
LOCAL cImagen   := ""

   nHandle := Fopen( cPicture )

   IF Ferror() <> 0
            msgbox("Error File ")
                RETURN .F.
        ELSE
      nSize := Fseek( nHandle, 0, FS_END )
      Fseek( nHandle, 0 )
      nRead := Fread( nHandle, @cImagen, nSize )
      IF nRead <> nSize
         msgbox("error read ? ")
         Fclose( nHandle )
               RETURN .F.
      END IF

   END IF

   FClose( nHandle )

RETURN cImagen

Function ConvertXbase(xVal )
LOCAL cValtype := Valtype(xVal)
Local nDay,nMonth, nYear


IF cValtype == 'C' .or. cValtype == 'M'
   if empty(xVal)
      xVal := " "
   endif
   return alltrim(xVal)

ELSEIF cValtype == 'N'
    if empty(xVal)
        xVal :=  0
    endif
   cNum := Alltrim(Str(xVal))
   RETURN  val(cNum)

ELSEIF cValtype == 'L'
   IF xVal
     RETURN '.T.'
   ENDIF
   RETURN '.F.'

Else
    if empty(xVal)
       xVal := " "
    endif
   return alltrim(xVal)
ENDIF

RETURN ''

/*------------------------------------------------------------------------------*/
FUNCTION HpSToD(cDate)
/*------------------------------------------------------------------------------*/
LOCAL cDate1 := alltrim(cDate)
LOCAL nL:= LEN(cDate)
LOCAL cYear,cMonth,cDay
LOCAL dDate

    Set( _SET_DATEFORMAT, 'dd-mm-yyyy' )

    IF empty(cDate)
       return CTOD("")
    ENDIF

    IF nL == 8
       cYear  := Val(SUBSTR(cDate1,1,4))
       cMonth := Val(SUBSTR(cDate1,5,2))
       cDay   := VaL(SUBSTR(cDate1,7,2))

    ELSEIF nLong == 7
       cYear  := Val(SUBSTR(cDate1,1,4))
       cMonth := Val(SUBSTR(cDate1,5,2))
       cDay   := Val(SUBSTR(cDate1,7,1))

    ELSEIF nLong == 6
       cYear  := Val(SUBSTR(cDate1,1,4))
       cMonth := Val(SUBSTR(cDate1,5,1))
       cDay   := Val(SUBSTR(cDate1,6,1))

    ENDIF

RETURN dDate:= CTOD(STRZERO(cDay,2)+"-"+STRZERO(cMonth,2)+"-"+STRZERO(cYear,4))