//---------------------------------------------------------------------------//
//  MYSQL.PRG
//
//  Author: Hector Pezoa - `HPGSOFT - 2007
//  Realizada con la libreria Ot4xb de Pablo Botella
//  Version Actualizada
//  Algunos metodos o ideas estan basados en la excelente
//  libreria de Manu Exposito  Eagle
//
//  Realized with the library Ot4xb of Pablo Botella   Get The Open Tools for Xbase++
//  here: http://www.xbwin.com
//
//  Some methods or ideas are based on the excellent
//  library Eagle of Manu Exposito
//  Contents://
//---------------------------------------------------------------------------//

#include "dll.ch"
#include "ot4xb.ch"
#include "common.ch"
#INCLUDE "appevent.ch"
#INCLUDE "mysql.ch"
#INCLUDE "dbstruct.ch"


#PRAGMA LIBRARY( "ot4xb.LIB" )
 //---------------------------------------------------------------------------//
   CLASS MySql

   EXPORTED:
   VAR pMySql, aDBases , cDb , cServer ,cUser, cPassWord ,cDbName ,nPort ,cSocket,nFlag,lOK
   VAR cDatabase ,aTables
  //---------------------------------------------------------------------------//
   INLINE METHOD Init()
   if Empty( ::pMySql )
      ::pMySql := 0
   else
       MySQLError(::pMySql, "See MySqllib.dll")
   return 0
   end

  ::pMySql := mysql_init(::pMySql)

  return Self
//---------------------------------------------------------------------------//
   INLINE METHOD RealConnect(host,User,Password, Db ,Port,Socket,Flag)
   ::cServer      := iif(Empty(host),'localhost', host)
   ::cUser        := iif(Empty(User),'root', User)
   ::cPassWord    := iif(Empty(Password),'', Password)
   ::cDbName      := iif(Empty(Db),'',Db)
   ::nPort        := iif(Empty(Port),0, Port)
   ::cSocket      := iif(Empty(Socket),'', Socket)
   ::nFlag        := iif(Empty(Flag),0, Flag)
   ::lOk          := .F.
   ::aDBases   := {}
   ::aTables   := {}

    if ::pMySql > 0

       if  mysql_real_connect(::pMysql,::cServer,::cUser,::cPassword,::cDbName,::nPort,::cSocket,::nFlag ) = 0
           MySQLError(::pMySql, "Cannot connect to database")
           ::close()
           return .f.
       else
            ::aDBases :=  ::Show(SHOW_DATABASES)
            if ValType( ::cDbName ) == "C"  .and. len(::cDbName) >0
                ::SelectDB(::cDbName )
            endif
           ::lOK := .t.
      endif
    endif

   return ::lOK
//---------------------------------------------------------------------------//
   INLINE METHOD AffectedRows() ; return mysql_affected_rows( ::pMySql )
//---------------------------------------------------------------------------//
   INLINE METHOD AutoCommit(lMode) ; return  mysql_autocommit(::pMySql, lMode)
//---------------------------------------------------------------------------//
   INLINE METHOD ChangeUser(cUser,cPassword, cDb) ; return mysql_change_user(::pMySql, cUser, cPassword, cDb)
 //---------------------------------------------------------------------------//
  INLINE METHOD CharacterSetName() ; return  mysql_character_set_name(::pMySql)
 //---------------------------------------------------------------------------//
  INLINE METHOD Close();  return mysql_close(::pMySql)
 //---------------------------------------------------------------------------//
  INLINE METHOD Commit(); return mysql_commit(::pMySql)
 //---------------------------------------------------------------------------//
  INLINE METHOD CreateDb(cDb)
    Local cSql :=  "CREATE DATABASE "+  cDb

     if(!::ExisteDb(cDb))
         if ::Query(cSql ) == 0
            return .T.
         end
     endif
    return .F.
//---------------------------------------------------------------------------//
  INLINE METHOD DropDb(cDb) ; return mysql_drop_db(::pMySql, cDb)        // usar mysql_query
//---------------------------------------------------------------------------//
  INLINE METHOD DumpDebugInfo();  return mysql_dump_debug_info(::pMSql)
//---------------------------------------------------------------------------//
  INLINE METHOD GetLastError() ; return MySQL_GetLastErrorNo(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD GetLastErrorMsg() ; return MySQL_GetLastErrorMsg(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD ErrMsg() ; return mysql_error(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD ErrCode() ; return mysql_errno(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD FieldCount() ; return mysql_field_count(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD GetHostInfo() ; return mysql_get_host_info(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD GetProtoInfo(); return mysql_get_proto_info(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD GetServerInfo(); return mysql_get_server_info(::pMySql)
 //---------------------------------------------------------------------------//
  INLINE METHOD GetServerVersion() ; return  mysql_get_server_version(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD Info(); return mysql_info(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD InsertId(); return  mysql_insert_id(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD Kill(nPid ) ; return mysql_kill(::pMySql, nPid)
//---------------------------------------------------------------------------//
  INLINE METHOD ExisteDb(cWild)
   Local lOk
           if empty(cWild)
               MyerrorLog(MY014)
               return .f.
          endif

   return (lOk :=  AScan(::aDBases , cWild ) > 0)
//---------------------------------------------------------------------------//
  INLINE METHOD ListFields( cTable , cWild )
   Local p := mysql_list_fields(::pMySql, cTable,cWild)
   if p  == 0 ; return NIL ; end
   return p
 //---------------------------------------------------------------------------//
  INLINE METHOD ListProcesses()
   local p := mysql_list_processes(::pMySql)
   if p  == 0 ; return NIL ; end
   return p
 //---------------------------------------------------------------------------//
  INLINE METHOD ListTables(cWild) ; return ( ::aTables := ::show( SHOW_TABLES  ,cWild))
//---------------------------------------------------------------------------//
  INLINE METHOD ExistTables(cWild)
   local lOk

          if empty(cWild)
         **    msgbox("Debe Indicar Nombre Tabla")
              MyerrorLog(MY015)
            return .f.

          elseif len(::aTables) = 0
             ::ListTables()
          endif
  return (lOk :=  AScan( ::aTables, cWild ) > 0)

  //---------------------------------------------------------------------------//
  INLINE METHOD  MoreResults(); return mysql_more_results(::pMySql)
 //---------------------------------------------------------------------------//
  INLINE METHOD  NextResult(); return mysql_next_result(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD  Options(mEnum,cArg); return  mysql_options(::pMySql, nEnum,cArg)
 //---------------------------------------------------------------------------//
  INLINE METHOD  Ping(); return mysql_ping(::pMySql)
 //---------------------------------------------------------------------------//
  INLINE METHOD  Query(cQuery); return  mysql_query(::pMySql, cQuery)
 //---------------------------------------------------------------------------//
  INLINE METHOD  RealEscapeString(cStr);  return mysql_real_escape_string(::pMySql,cStr)
//---------------------------------------------------------------------------//
  INLINE METHOD  RealQuery(cQuery);  return mysql_real_query(::pMySql, cQuery)
 //---------------------------------------------------------------------------//
  INLINE METHOD  Reload();  return mysql_reload(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD  Rollback() ; return mysql_rollback(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD  SelectDb(cDb)
   local lOk := .f.
        if  mysql_select_db(::pMySql, cDb) = 0
            ::cDatabase := cDb
             lOk :=  .T.
         endif
  return lOk
//---------------------------------------------------------------------------//
  INLINE METHOD  SetServerOption( nEnum ); return mysql_set_server_option(::pMySql, nEnum )
//---------------------------------------------------------------------------//
  INLINE METHOD  Schutdown(nEnum); return  mysql_shutdown(::pMySql, nEnum)
//---------------------------------------------------------------------------//
  INLINE METHOD  SqlState() ; return mysql_sqlstate(::pMySql)
 //---------------------------------------------------------------------------//
  INLINE METHOD  SslSet(ckey,ccert,ca,capath,cipher); return  mysql_ssl_set(::pMySql,ckey,ccert, ca,capath, cipher)
 //---------------------------------------------------------------------------//
  INLINE METHOD  nStat() ; return mysql_stat(::pMySql)
 //---------------------------------------------------------------------------//
  INLINE METHOD  StoreResult()
   local p  := mysql_store_result(::pMySql)
   if p == 0 ; return NIL ; end
   return p
//---------------------------------------------------------------------------//
  INLINE METHOD  Thread_Id() ; return mysql_thread_id(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD  UseResult()
   local p :=  mysql_use_result(::pMySql)
   if p == 0 ; return NIL ; end
   return p
//---------------------------------------------------------------------------//
  INLINE METHOD WarningCount(); return  mysql_warning_count(::pMySql)
//---------------------------------------------------------------------------//
  INLINE METHOD _lock_( n ) ; n := 0 ; return :: pMySql
//---------------------------------------------------------------------------//
  INLINE METHOD _unlock_() ; return NIL
 //---------------------------------------------------------------------------//
  INLINE METHOD Show(nType,cDb)
   local cSql , aBases := {}
   local aPFields , pResult ,nTipo

    Do case
        Case nType = SHOW_DATABASES     ; cSql := "SHOW DATABASES"   ; nTipo = 1
        Case nType = SHOW_STATUS        ; cSql := "SHOW STATUS "     ; nTipo = 2
        Case nType = SHOW_VARIABLES     ; cSql := "SHOW VARIABLES "  ; nTipo = 2
        case nType = SHOW_PRIVILEGES    ; cSql := "SHOW PRIVILEGES"  ; nTipo = 2
        Case nType = SHOW_TABLES
             if !empty( cDb )
                 cSql := "SHOW TABLES "+"FROM "+ cDb ; nTipo = 1
             else
                 cSql :=  "SHOW TABLES " ; nTipo = 1
            endif
    EndCase

    if ::Query(cSql ) == 0
        pResult = ::StoreResult()

        if pResult > 1
           aBases := Array( mysql_num_rows(pResult))

           IF len(aBases) = 0
                  mysql_free_result(pResult)
                  return  aBases
          ENDIF
           for i := 1 to len(aBases)
              aPFields := mysql_fetch_row(pResult)
              if( aPFields != NIL )
                  if nTipo =  1
                     aBases[i] := aPFields[1]
                  elseif nTipo = 2
                      aBases[i] := aPFields
                  endif
              end
           next
            mysql_free_result(pResult)
        endif
     else
          MySQLError(::pMySql, "ShowDatas")
    endif

 return aBases
//---------------------------------------------------------------------------//
 INLINE METHOD OptimizeTable( cTable)
 local lRet := .f.

  if  ::ExistTables(cTable)
      if ::RealQuery( "OPTIMIZE TABLE " + cTable ) == 0
          lRet := .t.
      endif
  endif
return( lRet )
 //---------------------------------------------------------------------------//
INLINE METHOD CheckTable( cTable)
local lRet := .f.
     if ::ExistTables( cTable )
           if ::RealQuery( "CHECK TABLE " + cTable ) == 0
              lRet := .t.
           endif
     endif
return( lRet )
//---------------------------------------------------------------------------//
 INLINE METHOD RepairTable( cTable)
local lRet := .f.
     if ::ExistTables( cTable )
        if ::RealQuery( "REPAIR TABLE " + cTbName ) == 0
           lRet := .t.
        endif
     endif
return( lRet )
//---------------------------------------------------------------------------//
 INLINE METHOD DropTable( cTable)
local lRet := .f.
   if ::ExistTables( cTable )
       if ::RealQuery("DROP TABLE " + cTable ) == 0
           ::ListTables()
           lRet := .T.
      endif
   endif
return( lRet )
//-----------------------------------------------------------------------------
  INLINE METHOD CreateIndex(cTable, cIndex, aCol, lUnique )
 local nLen := 0
 local i := 0
 Local cSql := "CREATE "

 if ::ExistTables( cTable )

    if ValType( lUnique ) == "L" .and. lUnique
        cSql += "UNIQUE "
    endif

    cSql += "INDEX " + cIndex + " ON " + cTable + " ( "

    if ValType( aCol ) == "A"
        nLen := len( aCol ) - 1
        FOR i := 1 TO nLen
            cSql += aCol[ i ] + ", "
        NEXT
        cSql += aCol[ nLen + 1 ] + " )"
    else
        cSql += aCol + " )"
    endif
 endif

return(::RealQuery( cSql ) )
//---------------------------------------------------------------------------//
 INLINE METHOD DropIndex( cTable, cIndex )
  local cSql

       if ::ExistTables( cTable )
          cSql :=  "DROP INDEX " + cIndex + " ON " + cTable
       endif

  return( ::RealQuery( cSql ) )
//---------------------------------------------------------------------------//
 INLINE METHOD CreatePrimaryKey( cTable, aCol )
 local nLen := 0
 local i := 0
 local cSql := "ALTER TABLE " + cTable + " ADD PRIMARY KEY ( "

  if ::ExistTables( cTable )
    if ValType( aCol ) == "A"
        nLen := len( aCol ) - 1
        FOR i := 1 TO nLen
            cSql += aCol[ i ] + ", "
        NEXT
        cSql += aCol[ nLen + 1 ] + " )"
    else
        cSql += aCol + " )"
    endif
  endif

 return(::RealQuery( cSql ) )
//---------------------------------------------------------------------------//
 INLINE METHOD CreateTable( cTable,aStruct,cType)
 local lRet := .f.
 local n := 0
 local nLen := 0
 local cSql := ""

     IF len(::aTables) = 0
        ::ListTables()
     endif

    if ValType( cTable ) != "C"
       msgbox( "Debe entrar un nombre de tabla correcto" )

       return lRet

    elseif ValType( aStruct ) != "A"
       msgbox( "Debe entrar la estructura de tabla" )
        return lRet
    else
        IF  ::ExistTables( cTable )
            msgbox('ya existe tabla')
            return lRet
         endif
    endif

    nLen := len( aStruct ) - 1
    cSql := 'CREATE TABLE ' + cTable   + ' ( '
    FOR n := 1 TO nLen
             cSql += aStruct[ n, DBS_NAME ] + ' ' +  TipoField( aStruct[ n, DBS_TYPE ], ;
             aStruct[ n, DBS_LEN ],  aStruct[ n, DBS_DEC ] ) + ', '
   NEXT
   n := nLen + 1
   cSql += aStruct[ n, DBS_NAME ] + ' ' + TipoField( aStruct[ n, DBS_TYPE ], ;
   aStruct[ n, DBS_LEN ],  aStruct[ n, DBS_DEC ] ) + ' )'

   if ValType( cType ) == "C"
      cType := upper( cType )

      if cType == "BERKELEYDB" .or. ;
         cType == "GEMINI" .or.     ;
         cType == "MERGE" .or.      ;
         cType == "INNODB" .or.     ;
         cType == "MYISAM" .or.     ;
         cType == "MRG_MYISAM" .or. ;
         cType == "ISAM" .or.       ;
         cType == "HEAP" .or.       ;
         cType == "DBD"
         cSql += ' TYPE = ' + cType
     endif
  endif
  cSql += ';'

  if  ::RealQuery( cSql ) == 0
      ::ListTables()
      lRet := .T.
  endif

return( lRet )

ENDCLASS
//-----------------------------------------------------------------------------


