// myslq.ch



#define    MY_FLUSH_ALL  0
#define    MY_FLUSH_HOSTS  1
#define    MY_FLUSH_LOGS  2
#define    MY_FLUSH_PRIVILEGES  3
#define    MY_FLUSH_STATUS  4
#define    MY_FLUSH_TABLES  5
#define    MY_FLUSH_TABLES_WITH_READ_LOCK  6

#define    MY_LOCK_READ  1
#define    MY_LOCK_READ_LOCAL  2
#define    MY_LOCK_WRITE  3
#define    MY_LOCK_LOW_PRIORITY_WRITE  4


#define    SHOW_DATABASES      1
#define    SHOW_TABLES         2
#define    SHOW_COLUMNS        3
#define    SHOW_INDEX          4
#define    SHOW_TABLE_STATUS   5
#define    SHOW_STATUS         6
#define    SHOW_VARIABLES      7
#define    SHOW_LOGS           8
#define    SHOW_PROCESSLIST    9
#define    SHOW_GRANTS_FOR    10
#define    SHOW_CREATE_TABLE  11
#define    SHOW_MASTER_STATUS 12
#define    SHOW_MASTER_LOGS   13
#define    SHOW_SLAVE_STATUS  14
#define    SHOW_WARNINGS      15
#define    SHOW_ERRORS        16
#define    SHOW_TABLE_TYPES   17
#define    SHOW_PRIVILEGES    18

// MySQL field types
// NOTE: TINY is used to map clipper logical values to MySQL tables, so 0 == .F., 1 == .T.

#define  MYSQL_DECIMAL_TYPE      0
#define  MYSQL_TINY_TYPE         1
#define  MYSQL_SHORT_TYPE        2
#define  MYSQL_LONG_TYPE         3
#define  MYSQL_FLOAT_TYPE        4
#define  MYSQL_DOUBLE_TYPE       5
#define  MYSQL_NULL_TYPE         6
#define  MYSQL_TIMESTAMP_TYPE    7
#define  MYSQL_LONGLONG_TYPE     8
#define  MYSQL_INT24_TYPE        9
#define  MYSQL_DATE_TYPE         10
#define  MYSQL_TIME_TYPE         11
#define  MYSQL_DATETIME_TYPE     12
#define  MYSQL_YEAR_TYPE         13
#define  MYSQL_NEWDATE_TYPE      14
#define  MYSQL_VARCHAR_TYPE      15
#define  MYSQL_NEW_DECIMAL_TYPE  246
#define  MYSQL_ENUMTYPE          247
#define  MYSQL_SET_TYPE          248
#define  MYSQL_TINY_BLOB_TYPE    249
#define  MYSQL_MEDIUM_BLOB_TYPE  250
#define  MYSQL_LONG_BLOB_TYPE    251
#define  MYSQL_BLOB_TYPE         252
#define  MYSQL_VAR_STRING_TYPE   253
#define  MYSQL_STRING_TYPE       254
#define  MYSQL_GEOMETRY_TYPE     255





// MySQL field structure item number

#define  MYSQL_FS_NAME           1     /* Name of column */
#define  MYSQL_FS_TYPEXBASE      2     /*Type of field Xbase */
#define  MYSQL_FS_LENGTH         3     /* Width of col*/
#define  MYSQL_FS_DECIMALS       4     /* Number of decimals in field */
#define  MYSQL_FS_FLAGS          5     /* Div flags */
#define  MYSQL_FS_TYPE           6     /* Type of field Se mysql_com.h for types */

// MySQL field flags

#define  NOT_NULL_FLAG         1              /* Field can't be NULL */
#define  PRI_KEY_FLAG          2              /* Field is part of a primary key */
#define  UNIQUE_KEY_FLAG       4              /* Field is part of a unique key */
#define  MULTIPLE_KEY_FLAG     8              /* Field is part of a key */
#define  BLOB_FLAG            16             /* Field is a blob */
#define  UNSIGNED_FLAG        32             /* Field is unsigned */
#define  ZEROFILL_FLAG        64             /* Field is zerofill */
#define  BINARY_FLAG         128
/* The following are only sent to new clients */
#define  ENUM_FLAG               256		/* field is an enum */
#define  AUTO_INCREMENT_FLAG     512		/* field is a autoincrement field */
#define  TIMESTAMP_FLAG          1024		/* Field is a timestamp */
#define  PART_KEY_FLAG           16384		/* Intern; Part of some key */
#define  GROUP_FLAG              32768		/* Intern group field */


*//---------------------------------------------------------------
* mysql tables type:
*    TINYINT[(length)] [UNSIGNED] [ZEROFILL]
*  | SMALLINT[(length)] [UNSIGNED] [ZEROFILL]
*  | MEDIUMINT[(length)] [UNSIGNED] [ZEROFILL]
*  | INT[(length)] [UNSIGNED] [ZEROFILL]
*  | INTEGER[(length)] [UNSIGNED] [ZEROFILL]
*  | BIGINT[(length)] [UNSIGNED] [ZEROFILL]
*  | REAL[(length,decimals)] [UNSIGNED] [ZEROFILL]
*  | DOUBLE[(length,decimals)] [UNSIGNED] [ZEROFILL]
*  | FLOAT[(length,decimals)] [UNSIGNED] [ZEROFILL]
*  | DECIMAL(length,decimals) [UNSIGNED] [ZEROFILL]
*  | NUMERIC(length,decimals) [UNSIGNED] [ZEROFILL]
*  | DATE
*  | TIME
*  | TIMESTAMP
*  | DATETIME
*  | CHAR(length) [BINARY | ASCII | UNICODE]
*  | VARCHAR(length) [BINARY]
*  | TINYBLOB
*  | BLOB
*  | MEDIUMBLOB
*  | LONGBLOB
*  | TINYTEXT [BINARY]
*  | TEXT [BINARY]
*  | MEDIUMTEXT [BINARY]
*  | LONGTEXT [BINARY]
*  | ENUM(value1,value2,value3,...)
*  | SET(value1,value2,value3,...)
*  | spatial_type
*/




