//
//  FECHA MOD.: 11/12/2006
//
//  VERSION...: 5.02
//  AUTHOR  : MANUEL EXPOSITO
//  PROPOSITO.: Ejemplo de mantenimiento simple de una tabla
//  agregar, eliminar, modificar, consultar, buscar , uso de
//  un browse  estilo  hibrido
//
//  INTENTION.: Example of simple maintenance of a table
//  add, eliminate, modify, a query, look, find . use of
//  a browse hybrid style

//----------------------------------------------------------------------------//

//-- Definiciones  ------------------------------------------------------------//

#define B_BOX ( CHR( 218 ) + CHR( 196 ) + CHR( 191 ) + CHR( 179 ) + ;
                CHR( 217 ) + CHR( 196 ) + CHR( 192 ) + CHR( 179 ) + " " )

#define ID_CONSUTA  0
#define ID_MODIFICA 1
#define ID_ALTA     2
#define ID_BORRA    3

//-- Includes ----------------------------------------------------------------//

#include "InKey.ch"


//-- Modulo principal --------------------------------------------------------//

procedure main()

    local cHost   := "localhost"
    local cUser   := "root"
    local cPwd    := ""
    local cDb     := "facturacion"
    local cTable  := "notes"
    local oCon, oTb  ,p1,p2
    local aStruct := { ;
                        { "FIRST",      "C", 20, 00 },;
                        { "LAST",       "C", 20, 00 },;
                        { "STREET",     "C", 30, 00 },;
                        { "CITY",       "C", 30, 00 },;
                        { "STATE",      "C", 02, 00 },;
                        { "ZIP",        "C", 10, 00 },;
                        { "HIREDATE",   "D", 08, 00 },;
                        { "MARRIED",    "L", 01, 00 },;
                        { "AGE",        "N", 02, 00 },;
                        { "SALARY",     "N", 06, 00 },;
                        { "NOTES",      "C", 70, 00 } ;
                     }

      set date italian   //french
      set century on

      cls
    // Creamos objeto conexion
    oCon:= MySql():New()
      // Intentamos la conexion
    IF  oCon:RealConnect(cHost,cUser,cPwd )
       // Comprobamos si ya existe la DB

       if !oCon:ExisteDb( cDb )
           oCon:CreateDb( cDb )
       endif
       oCon:SelectDb( cDb )
       IF   !(oCon:ExistTables(cTable))
             if  !(oCon:CreateTable( cTable,aStruct))
                 msgbox('no es posible crear tabla')
                 oCon:Close()
                 return
             endif
      endif
      oTbl := MyResult():New(oCon,,cTable)
      if oTbl:OpenRecord()
         // Si no hay registros insertamos uno para que funcione el Browse -If there are no records we insert one so that the Browse works
          if ( oTbl:RecCount() == 0 )
            // Si no hay datos al menos introducimos uno...If there is no information at least we introduce one..
            // Llenamos el buffer con los valores -  We fill the buffer with the values
                oTbl:aBuffer := { "Hector", ;
                                 "Pezoa", ;
                                 "Osorno", ;
                                 "SE", ;
                                 "CH", ;
                                 "41700", ;
                                 date(), ;
                                 .t., ;
                                 42, ;
                                 150000, ;
                                 "Mi primer registro..." }
                // Inserto el registro y traigo el resultado al cliente -- insert the record and bring the result to the client
                oTbl:Insert( )
             endif
            // Abrimos el Browse   -- open browse
            GestBrw( oTbl )
         endif
        // Liberamos la memoria ocupada por el objeto tabla --  liberate the memory occupied by the object table
        oTbl:Close()
    endif
    // Liberamos la memoria de la conexion  ---  liberate the memory of the connection
    oCon:Close()
return
//-- Modulos auxiliares  ------------------------------------------------------//
//----------------------------------------------------------------------------//
// Gestion completa de una tabla MySQL
static procedure GestBrw( oTb )
local oBrw, oCol
local lEnd := .f.
local nKey, n, nFld

    oBrw := TBrowseNew( 1, 0, MaxRow() - 1, MaxCol() )

    oBrw:colorSpec := "W+/B, N/BG"
    oBrw:ColSep    := "  "
    oBrw:HeadSep   := ""
    oBrw:FootSep   := ""
    // Asignamos los bloques de codigo de movimientos del cursor   --assign the blocks of code of movements of the cursor
    // de datos   -----of information

     MySetBrowse( oBrw, oTb )
    nFld := oTb:FieldCount()

    oBrw:AddColumn( TBColumnNew( "Reg. #", { || oTb:RecNo() } ) )

    FOR n := 1 TO nFld
        oBrw:AddColumn( TBColumnNew( oTb:FieldName( n ), GenCB( oTb, n )  ) )
    NEXT
    columna := oBrw:getcolumn(8)
    columna:colorblock:= { |d|if(d < ctod("01/01/2003"), {6,5},{1,2} ) }
    cls
    @ 0, 0 SAY PadC( "Look the Table : " + ;
                        upper( oTb:cTable ), MaxCol() + 1, " " ) COLOR   "W+/G+"

    @ MaxRow(),         0 SAY "INS"                 COLOR "GR+/R+"    //insert
    @ MaxRow(), Col() + 1 SAY "New  "               COLOR "W+/R+"    // new record
    @ MaxRow(), Col() + 1 SAY "ENTER"               COLOR "GR+/R+"   // enter
    @ MaxRow(), Col() + 1 SAY "Mod."                COLOR "W+/R+"     // modify
    @ MaxRow(), Col() + 1 SAY "SUPR"                COLOR "GR+/R+"   // delete
    @ MaxRow(), Col() + 1 SAY "Delete"              COLOR "W+/R+"    //delete
    @ MaxRow(), Col() + 1 SAY "F1"                  COLOR "GR+/R+"   // f1
    @ MaxRow(), Col() + 1 SAY "Help"                COLOR "W+/R+"     // help
    @ MaxRow(), Col() + 1 SAY "F4"                  COLOR "GR+/R+"    // f4
    @ MaxRow(), Col() + 1 SAY "Order"               COLOR "W+/R+"     // order
    @ MaxRow(), Col() + 1 SAY "F5"                  COLOR "GR+/R+"    // f5
    @ MaxRow(), Col() + 1 SAY "Find"                COLOR "W+/R+"     // find
    @ MaxRow(), Col() + 1 SAY "F6"                  COLOR "GR+/R+"    // f6
    @ MaxRow(), Col() + 1 SAY "Find ->"             COLOR "W+/R+"     // find next
    @ MaxRow(), Col() + 1 SAY "ESC"                 COLOR "GR+/R+"    // escape
    @ MaxRow(), Col() + 1 SAY "Exit"                COLOR "W+/R+"     // exit

     while !lEnd

    oBrw:ForceStable()
      nKey = InKey( 0 )

      do case
         case nKey == K_ESC             // Salir                  Exit
              SetPos( MaxRow(), 0 )
              lEnd = .t.

         case nKey == K_DOWN    // Fila siguiente    --- row next
               if oTb:Recno()< oTb:nRows
                 oBrw:Down()
               endif

         case nKey == K_F3
              oBrw:Configure()

         case nKey == K_F4              // Establece el orden     ----- Order
                if ElOrden( oTb )
                    oBrw:goTop()
                endif

         case nKey == K_F5              // Busca valor en columna   --- Find Column
            if BuscaValor( oTb )
                Msgbox( "Find..." )                    // find
            else
                Msgbox( "Value no found." )           //value no found
                oTb:GoTop()
            endif
            oBrw:RefreshAll()

         case nKey == K_F6              // Busca siguiente columna  --- find next column
             if oTb:FindNext()
                Msgbox( "Find..." )                    //find
            else
                Msgbox( "Value no found..." )            // value no found
                oTb:GoTop()
            endif
            oBrw:RefreshAll()

         case nKey == K_UP            // Fila anterior
              IF oTb:nCurRow > 1
                oBrw:Up()
           endif

          case nKey == K_LEFT            // Va a la columna anterior
              oBrw:Left()

         case nKey == K_RIGHT           // Va a la columna siguiente
              oBrw:Right()

         case nKey = K_PGDN             // Va a la pagina siguiente
            oBrw:pageDown()

         case nKey = K_PGUP             // Va a la pagina antrior
            oBrw:pageUp()

         case nKey = K_CTRL_PGUP        // Va al principio
           oBrw:goTop()

         case nKey = K_CTRL_PGDN        // Va al final
           oBrw:goBottom()

         case nKey = K_HOME             // Va a la primera columna  visible
              oBrw:home()

         case nKey = K_END              // Va a la ultima columna visible
              oBrw:end()

         case nKey = K_CTRL_LEFT        // Va a la primera columna
              oBrw:panLeft()

         case nKey = K_CTRL_RIGHT       // Va a la ultima columna
              oBrw:panRight()

         case nKey = K_CTRL_HOME        // Va a la primera pgina
              oBrw:panHome()

         case nKey = K_CTRL_END         // Va a la ltima pgina
              oBrw:panEnd()

         case nKey = K_DEL              // Borra fila                //delete row
              Borrar( oTb, oBrw )

         case nKey = K_INS              // Inserta columna            // insert column
              Insertar( oTb, oBrw )

         case nKey = K_ENTER            // Modifica columna           // modift column
            Modificar( oTb, oBrw )

         case nKey == K_F1              // Algunos datos
          //  Msgbox( "Datos de la tabla " + oTb:cTable + ";" + ;
          //         ";Registro actual......: " + Str( oTb:RecNo() ) + ;
          //         ";Total de registros...: " + Str( oTb:RecCount() ) +
          //         ";Total de columnas....: " + Str( oTb:FieldCount() )  )

      endcase

   end

return

//----------------------------------------------------------------------------//
// Crea los codeblock SETGET de las columnas del browse

static function GenCB( oTb, n )
return ( { || oTb:FieldGet( n ) } )
//----------------------------------------------------------------------------//
// Pantalla de datos de la tabla
static function PantMuestra( oTb, nTipo )
 local GetList := {}
 local cTipo, cId
    do case
        case nTipo == ID_ALTA
            cTipo := "Insert"      //insert
            cId := "New"
        case nTipo == ID_BORRA
        case nTipo == ID_CONSUTA
        case nTipo == ID_MODIFICA
            cTipo := "Modify"       //modify
            cId := StrNum( oTb:Recno() )
    end

    SET CURSOR ON

    DispBox( 3, 2, 18, 74, B_BOX )

    @ 04, 03 SAY cTipo + " records in the table " + oTb:cTable + " -  Number: " + cId

    @ 06, 03 SAY "First....:" GET oTb:First     PICTURE "@K"
    @ 07, 03 SAY "Last.....:" GET oTb:Last      PICTURE "@K"
    @ 08, 03 SAY "Street...:" GET oTb:Street    PICTURE "@K"
    @ 09, 03 SAY "City.....:" GET oTb:City      PICTURE "@K"
    @ 10, 03 SAY "State....:" GET oTb:State     PICTURE "@K"
    @ 11, 03 SAY "Zip......:" GET oTb:Zip       PICTURE "@K"
    @ 12, 03 SAY "Hiredate.:" GET oTb:Hiredate  PICTURE "@K"
    @ 13, 03 SAY "Married..:" GET oTb:Married   PICTURE "@K"
    @ 14, 03 SAY "Age......:" GET oTb:Age       PICTURE "999"
    @ 15, 03 SAY "Salary...:" GET oTb:Salary    PICTURE "999999"
    @ 16, 03 SAY "Notes:"
    @ 17, 03                  GET oTb:Notes     PICTURE "@K"

return( GetList )

//----------------------------------------------------------------------------//
// Inserta una fila

static procedure Insertar( oTb, oBrw )

    local GetList := {}
    local cPant := SaveScreen( 3, 2, 18, 74 )

    oTb:Blank(.t.)

    GetList := PantMuestra( oTb, ID_ALTA )
    READ

    set cursor off

    RestScreen( 3, 2, 18, 74, cPant )

    if LastKey() != K_ESC .and. Updated()
        if oTb:Insert()
            Alert( "Insert Tupla" )                                // insert tupla
            if Alert( "Refresh Browse?", { "Yes", "No" } ) == 1      // refresh browse
                oTb:Refresh()
                oBrw:goBottom()
                oBrw:RefreshAll()
            endif
        endif
    else
        oTb:Refresh()
         oBrw:goBottom()
         oBrw:RefreshAll()
    endif
  return

//----------------------------------------------------------------------------//
// Modifica la fila actual

static procedure Modificar(oTb,oBrw )

    local GetList := {}
    local nRecNo := oTb:RecNo()
    local cPant := SaveScreen( 3, 2, 18, 74 )

    oTb:LoadData()

    GetList := PantMuestra( oTb, ID_MODIFICA )
    READ

    set cursor off

    RestScreen( 3, 2, 18, 74, cPant )

    if LastKey() != K_ESC .and. Updated()
        if oTb:Update()
            Alert( "Modify Tupla" )                                // tupla modify
            if Alert( "Refresh Browse?", { "Yes", "No" } ) == 1      // refresh browse  yes or no
                oTb:Refresh()
                oTb:GoTo( nRecNo )
                oBrw:RefreshAll()
            endif
        endif
    endif

return

//----------------------------------------------------------------------------//
// Borra la fila actual
static procedure Borrar( oTb, oBrw )

    local nRecNo := oTb:RecNo()

    if Alert( "Realy want delete this record?", { "Yes", "No" } )  == 1     //  realy want delete this record yes or no
        if oTb:Delete( , 1 )
            Msgbox( "Delete on the Server" )                                //delete on the server
            if Alert( "Refresh Browse?", { "Yes", "No" } ) == 1        //refresh the browse yes or no
                oTb:Refresh()
                oTb:GoTo( nRecNo )
                oBrw:RefreshAll()
            endif
        endif
    else
        Alert( "error in the delete..." )                             // error in the delete
    endif

return

//----------------------------------------------------------------------------//
// Establece un nuevo orden de visualizacion

static function ElOrden( oTb )

    local i := oTb:FieldCount()
    local aFld := Array( i )
    local n, lRet

    FOR n := 1 TO i
        aFld[ n ] := oTb:FieldName( n )
    NEXT
    DispBox( 5, 9, 10, 25, B_BOX )

    i := 0
    i := AChoice( 6, 10, 9, 24, aFld )

    if lRet := ( i > 0 )
     //   Alert( "Order by  column " + StrNum( i ) + " " +  oTb:FieldName( i ) )
        oTb:SetOrder( i )
    endif

return( lRet )
//----------------------------------------------------------------------------//
// Busca un valor de una columna
static function BuscaValor( oTb )
    local GetList := {}
    local nCol := 0
    local lRet, uVal

    DispBox( 5, 5, 8, 75, B_BOX )

    @ 6, 10 SAY "Enter number column:" GET nCol PICTURE "@K"
    READ
    uVal := oTb:FieldGet( nCol )
    @ 7, 10 SAY "Enter value find:" GET uVal PICTURE "@K"
    READ
    lRet := oTb:Find( nCol, uVal, .t. )

return( lRet )

//----------------------------------------------------------------------------//
 function MySetBrowse( oBrw, oDataSource )

    local lRet := .t.
    local bGoTop, bGoBottom, bSkipper
    local cClsName

    if ValType( oBrw ) != "O" .or. ValType( oDataSource ) != "O"
        lRet := .f.
    else
      bGoTop :=    { || oDataSource:GoTop() }
      bGoBottom := { || oDataSource:GoBottom()}
      bSkipper :=  { | n | oDataSource:Skipper( n ) }

     cClsName := upper( oBrw:ClassName() )

      if cClsName == "TBROWSE"
            oBrw:goTopBlock := bGoTop
            oBrw:goBottomBlock := bGoBottom
            oBrw:SkipBlock := bSkipper
     else
        msgbox( "Error Type Browse " )             //error type browse
    endif

   endif

return( lRet )

function StrNum(n )
  n := 1

return( AllTrim( str( n ) ) )
